#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    conjure_object::private::DeriveWith
)]
#[serde(crate = "conjure_object::serde")]
#[derive_with(PartialEq, Eq, PartialOrd, Ord, Hash)]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct ComparisonTableDefinitionV2 {
    #[builder(default, into)]
    #[serde(rename = "title", skip_serializing_if = "Option::is_none", default)]
    title: Option<String>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::RangeAggregationDefinition>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(
        rename = "rangeAggregation",
        skip_serializing_if = "Option::is_none",
        default
    )]
    range_aggregation: Option<Box<super::RangeAggregationDefinition>>,
    #[builder(default, list(item(type = super::ComparisonTableColumn)))]
    #[serde(rename = "columns", skip_serializing_if = "Vec::is_empty", default)]
    columns: Vec<super::ComparisonTableColumn>,
}
impl ComparisonTableDefinitionV2 {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new() -> Self {
        Self::builder().build()
    }
    #[inline]
    pub fn title(&self) -> Option<&str> {
        self.title.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn range_aggregation(&self) -> Option<&super::RangeAggregationDefinition> {
        self.range_aggregation.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn columns(&self) -> &[super::ComparisonTableColumn] {
        &*self.columns
    }
}
